/*****************************************************************************
 * Machinist.h: DecSS DLL Header File
 *****************************************************************************
 * Copyright (C) 2001-2005 The Machinist
 *
 * Authors: theMachinist288@hotmail.com
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/
#pragma once

typedef void * HCSS;

#ifdef __cplusplus
extern "C"
{
#endif

	int  __stdcall CSSAuth(char *path);												// authenticated a drive

	HCSS __stdcall CSSCreate();														// creates a CSSCrack object and returns its handle
	void __stdcall CSSDestroy(HCSS hCSS);												// destroys a CSSCrack object

	int  __stdcall CSSOpen(char *path, HCSS hCSS);									// opens a file for cracking
	void __stdcall CSSClose(HCSS hCSS);												// closes cracked file

	int  __stdcall CSSDecrypt(unsigned char *pBuffer, __int64 fileOffset, HCSS hCSS);	// decrypt a block

#ifdef __cplusplus
}
#endif

// importing stuff
#ifndef MACHINIST_EXPORTS
#include "PDll.h"

class VirtualMachinist
{
	virtual int  CSSAuth(char *path) = 0;

	virtual HCSS CSSCreate() = 0;
	virtual void CSSDestroy(HCSS hCSS) = 0;

	virtual int  CSSOpen(char *path, HCSS hCSS) = 0;
	virtual void CSSClose(HCSS hCSS) = 0;

	virtual int  CSSDecrypt(unsigned char *pBuffer, __int64 fileOffset, HCSS hCSS) = 0;
};

class Machinist : public PDLL, public VirtualMachinist
{
public:
	// call the macro and pass your class name
//	DECLARE_CLASS(Machinist)

	DECLARE_FUNCTION1(int, CSSAuth, char *)

	DECLARE_FUNCTION0(HCSS, CSSCreate)
	DECLARE_FUNCTION1(void, CSSDestroy, HCSS)

	DECLARE_FUNCTION2(int, CSSOpen, char *, HCSS)
	DECLARE_FUNCTION1(void, CSSClose, HCSS)

	DECLARE_FUNCTION3(int, CSSDecrypt, unsigned char *, __int64, HCSS)

	int isAvailable;

	// hard code the dll name in the constructor
	Machinist()
	{
		SetDllName("Machinist.dll");
		if(Initialize() == false) isAvailable = 0;
		else					  isAvailable = 1;
	};
};
#endif