/*****************************************************************************
 * BitStreamWriter.h: Write to Bitstreams
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#if !defined(AFX_BITSTREAMWRITER_H__5F200465_3B1C_4C7B_BDDB_B7930D4DA18F__INCLUDED_)
#define AFX_BITSTREAMWRITER_H__5F200465_3B1C_4C7B_BDDB_B7930D4DA18F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <stdio.h>

/*
	see .cpp for comments...
*/

class BitStreamWriter
{
public:
	void WriteBits(int value,int count);
	void WriteBit(int value);

	bool Open(char *filename);
	void Close();

	BitStreamWriter();
	virtual ~BitStreamWriter();
private:
	void ResetBitBuffer();
	void SaveBuffer();
	void ResetBitStream();
	FILE *m_id;

	int m_bitpos;
	int m_bytepos;
	int m_bitbuffer_size;
	unsigned char *m_bitbuffer;
};

#endif // !defined(AFX_BITSTREAMWRITER_H__5F200465_3B1C_4C7B_BDDB_B7930D4DA18F__INCLUDED_)