/*****************************************************************************
 * PESPack.h: Read and Write PESPack Class
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#pragma once

#include "PESPacket.h"
#include "..\External\Machinist.h"

class PESPack
{
public:
	PESPack(void);
	PESPack(IOLayer *io);
	~PESPack(void);

	virtual int Read(IOLayer *io);
	virtual int Write(IOLayer *io);

	Machinist *CSS;
	HCSS hCSS;

	PESPacket Packet;
	static const int SECTOR_SIZE = 2048;
	int category;		// can be set by user
	__int64 fileOffset;

protected:
	BitStream bstream;
	unsigned char pBuffer[SECTOR_SIZE];
	unsigned char *pPESPacket;

	virtual int AddStuffingBytes(int bytes);
	virtual int DelStuffingBytes(int bytes);

	friend PESPacket;

#ifdef _DEBUG
	virtual void CheckConformance();
#endif
};
