/*****************************************************************************
 * PESPacket.h: PESPacket Buffer Class
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#pragma once

#include "BitStream.h"
#include "IOLayer.h"

class PESPacket
{
public:
	PESPacket(void);
	PESPacket(unsigned char *buffer, int length);
	~PESPacket(void);

	virtual int AttachBuffer(unsigned char *buffer, int length);
	virtual void SetPayLoadSize(int size);

	unsigned char *payLoad;
	unsigned char streamID, subStreamID;
	int maxPayLoadSize;
	int payLoadSize;
	int charge_size;
	int packetSize;

protected:
	BitStream bstream;
	int bufferSize;
	unsigned char *pBuffer;
};
