/*****************************************************************************
 * VideoSequence.h: Video Buffer Handling Class
 *****************************************************************************
 * Copyright (C) 2004-2005 ShrinkTo5
 *
 * Authors: Ocrana		 <info@shrinkto5.com>
 *          Andrej Grecu <info@shrinkto5.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111, USA.
 *****************************************************************************/

#pragma once

#include "Picture.h"
#include "BitStream.h"

class VideoSequence
{
public:
	VideoSequence(void);
	~VideoSequence(void);

	virtual int AttachBuffer(unsigned char *buffer, int length, unsigned char *wbuffer);
	virtual void SetAlert(TransferAlert *alert);					 // sets a pointer to an alert object
																	 // the alert object can be changed at will before and after setting it in transfer
	virtual void SetHyperSpeed();									 // mark the sequence as being skipped and shows hyperspeed logo
	virtual HBITMAP GenerateDCPicture(HDC hDC);

	BitrateControl BitRateControl;

	int numPictures;
	int width;
	int height;
	int absNumPicture;
	Picture Frame;
	int chroma_format;
	int aspect_ratio;
	int skipped;
	int demoMode;
	HANDLE hHyperSpeedBMP;

	STARTCODE_POS stPosLUT;

protected:
/*	unsigned char intra_qmatrix[64];
	unsigned char non_intra_qmatrix[64];
	unsigned char chroma_intra_qmatrix[64];
	unsigned char chroma_non_intra_qmatrix[64];*/

	int numIPictures;
	int numPPictures;
	int numBPictures;

	int absNumIPicture;
	int previewPicture;

	unsigned char *pBuffer;
	int bufferSize;

	BitStream bstream;
	CompressionStrategy Strategy;

	virtual int FindNextPictureStartCode(int *index);
//	virtual int CheckTransferability();
	virtual int FillStartCodePosLUT();

	TransferAlert *alert;

// quantizer matrix functions
/*	static const unsigned char default_intra_matrix[64];
	static const unsigned char scan[2][64];
	virtual void SetDefaultIntraMatrix(void);
	virtual void SetDefaultInterMatrix(void);
	virtual void LoadIntraMatrix(void);
	virtual void LoadInterMatrix(void);*/
	// not modified flag

};
