#pragma once
#include "afxcmn.h"
#include "afxwin.h"
#include "./GUI/BDialog.h"
#include "./GUI/SliderCtrlEx.h"
#include "./GUI/xSkinButton.h"
#include "./GUI/MltiTree.h"
#include "./GUI/TransparentButton.h"
#include <Transfer.h>
#include <process.h>
#include "WorkWindow.h"


// derived alert class
class UserTransferAlert : public TransferAlert
{
public:
	UserTransferAlert(void);
	~UserTransferAlert(void);

	virtual int CallBack(int alert, int param, void *pTransfer); 	
	virtual void SetBitmapStatic(CStatic *bmpStatic);

protected:
	CStatic *bmpStatic;
};
// CDoShrink-Dialogfeld
class CDoShrink : public CBDialog
{
	DECLARE_DYNAMIC(CDoShrink)

public:
	CDoShrink(CWnd* pParent = NULL);   // Standardkonstruktor
	virtual ~CDoShrink();

// Dialogfelddaten
	enum { IDD = IDD_SHRINK };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV-Untersttzung
	afx_msg void OnTimer(UINT nIDEvent);

	DECLARE_MESSAGE_MAP()

public:
	//ShrinkTo5 Init
	Transfer DVDTransfer;
	UserTransferAlert alert;
	//Default MFC Widgets
	CToolTipCtrl m_ToolTip;
	CEdit cInputFile;
	CEdit cOutputFile;
	CComboBox stdAud;
	CComboBox stdSub;
	CStatic mTargetGB;
	//Dialogs
	CWorkWindow smallWindow;
	//Own Widgets
	CTransparentButton movieOnly;
	CTransparentButton wholeDVD;
	CTransparentButton customDVD;
	CTransparentButton xDeposite;
	CTransparentButton xSpeedB;
	CSliderCtrlEx mSlider;
	CMultiTree VTSTree;
	CxSkinButton m_bStop;
	CxSkinButton m_bStart;
	CxSkinButton m_bSource;
	CxSkinButton m_bTarget;
	CxSkinButton xDown;
	//Special Vars
	CString mTemp;
	char stopFlag;
	float targetSizeGB;
	int savedCounter;
	bool DriveHopper;
	unsigned int threadHandle;
	CFont new_font;
	HTREEITEM currVTS[100];
	bool onWork;
	//afx_msg
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	afx_msg void OnBnClickedOpensource();
	afx_msg void OnBnClickedOpentarget();
	afx_msg void OnBnClickedStopbut();
	afx_msg void OnBnClickedMovieonly();
	afx_msg void OnBnClickedWholedvd();
	afx_msg void OnBnClickedCustom();
	afx_msg void OnBnClickedStartbut();
	afx_msg void OnBnClickedProsettings();
	//Virtuals
	virtual BOOL OnInitDialog();
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	//Own Functions
	void InsertVTSTreeItem(int i);
	void ReadVTSTree();
	void ReadVTSTreeItem(int i);
	void ReleaseVTSTreeView();
	void FillMultiLangGui();
	void EnableControls(BOOL show);
	void OnOpenImage();
};
