// TransparentButton.cpp : implementation file
//

#include "stdafx.h"
#include "..\ShrinkTo5Gui.h"
#include "TransparentButton.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CTransparentButton

CTransparentButton::CTransparentButton()
{
	m_bBlockErase = false;
	m_bAppThemed = false;
}

CTransparentButton::~CTransparentButton()
{
}


BEGIN_MESSAGE_MAP(CTransparentButton, CButton)
	//{{AFX_MSG_MAP(CTransparentButton)
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTransparentButton message handlers
//////////////////////////////////////////////////////////////////////////

bool IsThemeActiveEx()
{
	bool bThemeActive = false;
	HMODULE hinstDll = 0;

    // Check if the application is themed
    hinstDll = ::LoadLibrary(_T("UxTheme.dll"));
    if (hinstDll)
    {
        typedef BOOL (*ISAPPTHEMEDPROC)();
        ISAPPTHEMEDPROC pIsAppThemed;
        pIsAppThemed = 
          (ISAPPTHEMEDPROC) ::GetProcAddress(hinstDll, "IsAppThemed");

        if(pIsAppThemed)
            bThemeActive = (pIsAppThemed() == TRUE);
        
    }
	if(hinstDll)
		::FreeLibrary(hinstDll);

	return bThemeActive; //assume false if the dll is not found on the system (win9x !?)
}

//////////////////////////////////////////////////////////////////////////
BOOL CTransparentButton::OnEraseBkgnd(CDC* pDC) 
{
	CRect rc;
	
	if(!m_bAppThemed)
		return 1;


	if(m_bBlockErase)
	{	
		m_bBlockErase = false;
		return 1;
		
	}

	m_bBlockErase = true;
	
	HWND hParent = ::GetParent(m_hWnd);
	GetWindowRect(&rc); 
	::MapWindowPoints(0, hParent, (LPPOINT)&rc, 2);
	GetParent()->ScreenToClient(&rc);

	::InvalidateRect(hParent, &rc, 1);
	::UpdateWindow(hParent);
	
	
	HBRUSH hBrush = (HBRUSH)(GetProp(m_hWnd, PROP_HBRUSH));
	if(hBrush)
		return 1;
	
	DeleteObject(hBrush);

	GetWindowRect(&rc);

	 // Create a compatible DC
    HDC hDCMem = ::CreateCompatibleDC(pDC->m_hDC);
    HBITMAP hBmp = ::CreateCompatibleBitmap(pDC->m_hDC, rc.Width(), rc.Height());
    HBITMAP hBmpOld = (HBITMAP)(::SelectObject(hDCMem, hBmp));

	 
	BitBlt(hDCMem, 0, 0, rc.Width(), rc.Height(), pDC->m_hDC, 0, 0, SRCCOPY);
	
	hBrush = ::CreatePatternBrush(hBmp);

	// Cleanup
    ::DeleteObject(hBmp);
    ::DeleteDC(hDCMem);

	SetProp(m_hWnd, PROP_HBRUSH, hBrush);		
	
	return 1;	
}

void CTransparentButton::PreSubclassWindow() 
{
	CButton::PreSubclassWindow();

	m_bAppThemed = IsThemeActiveEx();
}
